//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 11-1 #1
//
// Displays a graph of a sine wave from 0 to 719 degrees.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define GRAPH_TITLE "Sin Graph"
#define GRAPH_SERIES1_TITLE "Sine"
#define GRAPH_X_MIN "0"
#define GRAPH_Y_MIN "-1"
#define GRAPH_X_MAX "719"
#define GRAPH_Y_MAX "1"

#include <graph_siow.h>
#include <math.h>

void main(void) 
{
   printf("Open graph in SIOW and then press button C1 on E3 board.\r\n");
   wait_for(PIN_C1);
   
   init_graph();
   
   for(int16 z = 0; z < 720; z++) {
      graph_point(sin((z*3.14)/180));
   }
   
   for(;;);
}
