//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 11-1 #3
//
// User enters 8 bytes of data in hex and 2 parity bytes. After entry the
// corrected 8 bytes are displayed or an error indicating the data cannot be
// corrected.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#define SIZE 8
#define BITS 8
#define NUMSIZE 3
#define BASE 16

void calcPar(int8 * numbers, int8 & row, int8 & col);
int1 correctIssues(int8 * number, int8 rowCalc, int8 rowPar, int8 colCalc, int8 colPar);

void main(void) 
{
   int8 entry[SIZE];
   int8 rowPar = 0;
   int8 colPar = 0;
   char num[NUMSIZE];
   
   for (;;)  {
      int8 rowCalc = 0;
      int8 colCalc = 0;
      printf ( "\r\nEnter 8 numbers in hex: " );
      
      for ( int i = 0; i < SIZE; i++ )   {
         get_string_usb ( num, NUMSIZE );
         entry[i] = (int ) strtol ( num, NULL, BASE );
         
         printf ( " " );
      }

      
      printf ( "\r\nEnter Row Parity: " );
      get_string_usb ( num, NUMSIZE );
      rowPar = (int ) strtol ( num, NULL, BASE );
      
      printf ( "\r\nEnter Column Parity: " );
      get_string_usb ( num, NUMSIZE );
      colPar = (int ) strtol ( num, NULL, BASE );
      
      int count = 0;
      
      do {
         rowCalc = 0; colCalc = 0;
         calcPar ( entry, rowCalc, colCalc );

         if ( ! correctIssues ( entry, rowCalc, rowPar, colCalc, colPar ) )
         break;
         count++;
      } while ( count < 5);

      
      if ( count >=  5)
         printf ( "\r\n\r\nUnable to correct numbers" );
   }

   
   for (;;) ;
}

void calcPar(int8 * numbers, int8 & row, int8 & col) {
   // Calc Row parity
   int i;
   
   for ( i = 0; i < SIZE; i++ )   {
      int sum = 0;
      
      for ( int j = 0; j < BITS; j++ )   {
         sum += bit_test ( numbers[i], j );
      }

      
      row += ((sum & 1 ) << i);
   }

   
   // calc Col parity
   for ( i = 0; i < BITS; i++ )   {
      int sum = 0;
      
      for ( int j = 0; j < SIZE; j++ )   {
         sum += bit_test ( numbers[j], i );
      }

      
      col += ((sum & 1 ) << i);
   }
}

int1 correctIssues(int8 * number, int8 rowCalc, int8 rowPar, int8 colCalc, int8 colPar) {
   int1 retVal;
   int i;
   
   if ( ( colCalc == colPar ) && ( rowCalc == rowPar ) )   {
      printf ( "\r\nNo Issues Found" );
      retVal = 0;
   }

   else {
   int8 rowDisc = rowCalc ^ rowPar;
   int8 colDisc = colCalc ^ colPar;
   
   // Target the culprit
   for ( i = 0; i < BITS; i++ ) { // Rows
      for ( int j = 0; j < BITS; j++ ) { // Cols
      if ( ( rowDisc & ( 1<<i ) ) && ( colDisc &  ( 1<<j ) ) )
      // Correct the bit
      number[i] ^= 1<<j;
      }
   }

   
      printf ( "\r\n\r\nCorrect Numbers are:\r\n" );
      for ( i = 0; i < BITS; i++ ) 
         printf ( " %x ", number[i] );
         
      retVal = 1;
   }

   
   return retVal;
}

